"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.manageCursor = void 0;
const utils_1 = require("../utils");
const manageCursor = (path, { componentHash }) => {
    let componentCursor;
    // manage cursor
    if (path.node.init &&
        path.node.init.type === 'CallExpression' &&
        path.node.init.callee &&
        path.node.init.callee.type === 'Identifier' &&
        (path.node.init.callee.name === 'useStore' ||
            path.node.init.callee.name === 'useState' ||
            path.node.init.callee.name === 'useRef')) {
        if (path.parent.type === 'VariableDeclaration') {
            if (path.parentPath.parent.type === 'BlockStatement') {
                const parent = path.parentPath.parentPath.parent;
                const parentPath = path.parentPath.parentPath.parentPath;
                if (parent.type === 'FunctionDeclaration') {
                    const componentName = parent.id.name;
                    componentCursor = componentName;
                    componentHash[componentName] = componentHash[componentName] || {
                        name: componentName,
                        refs: {},
                        state: {}
                    };
                }
                else if (parent.type === 'ArrowFunctionExpression') {
                    if (parentPath.parent.type === 'VariableDeclarator') {
                        if (parentPath.parent.id.type === 'Identifier') {
                            const componentName = parentPath.parent.id.name;
                            componentCursor = componentName;
                            componentHash[componentName] = componentHash[componentName] || {
                                name: componentName,
                                refs: {},
                                state: {}
                            };
                        }
                        else {
                            (0, utils_1.throwError)('cannot find ArrowFunctionExpression Component definition');
                        }
                    }
                }
                else {
                    (0, utils_1.throwError)('cannot find Component definition');
                }
            }
        }
    }
    return componentCursor;
};
exports.manageCursor = manageCursor;
