"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRefVariableDeclarator = exports.updateRefsIdentifier = void 0;
const t = __importStar(require("@babel/types"));
const utils_1 = require("../utils");
const updateRefsIdentifier = (path, { componentCursor, componentHash }) => {
    // in a MemberExpression?
    if (path.parent.type === 'MemberExpression') {
        return;
    }
    // in a VariableDeclarator?
    if (path.parent.type === 'VariableDeclarator') {
        return;
    }
    // is a ref the same name?
    if (!componentHash[componentCursor].refs.hasOwnProperty(path.node.name)) {
        return;
    }
    path.replaceWith(t.memberExpression(t.identifier(path.node.name), t.identifier('current')));
};
exports.updateRefsIdentifier = updateRefsIdentifier;
const useRefVariableDeclarator = (path, { componentCursor, componentHash }) => {
    if (path.node.init &&
        path.node.init.type === 'CallExpression' &&
        path.node.init.callee &&
        path.node.init.callee.type === 'Identifier' &&
        path.node.init.callee.name === 'useRef') {
        const node = path.node;
        if (node.id.type !== 'Identifier') {
            return (0, utils_1.throwError)('useRef must use an Identifier');
        }
        if (componentHash[componentCursor].refs[node.id.name] &&
            componentHash[componentCursor].refs[node.id.name].hasOwnProperty('type')) {
            // console.log(node.id)
            // throwError('refs variable is already defined!')
        }
        else {
            // TODO fix if case above so it can throw
            componentHash[componentCursor].refs[node.id.name] = {
                orig: 'useRef',
                type: 'ObjectProperty',
                used: false
            };
        }
    }
};
exports.useRefVariableDeclarator = useRefVariableDeclarator;
