"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.manageCursorArrowFunctionExpressionVariableDeclaration = exports.isTopLevelArrowFunctionExpressionVariableDeclaration = exports.manageCursorFunctionDeclaration = exports.isTopLevelFunctionDeclaration = exports.isTopLevelDefinition = exports.isJSXReturn = void 0;
const t = __importStar(require("@babel/types"));
const traverse_1 = __importDefault(require("@babel/traverse"));
const utils_1 = require("../../utils");
const isJSXReturn = (path) => {
    if (path.node.argument &&
        (path.node.argument.type === 'JSXElement' ||
            path.node.argument.type === 'JSXFragment')) {
        return true;
    }
    return false;
};
exports.isJSXReturn = isJSXReturn;
// function MyComponentFunc() { };
// export function myFunction2() { };
// export default function myFunction3() { }
const isTopLevelDefinition = (path) => {
    let atTopLevel = false;
    if (path.parent.type === 'ExportDefaultDeclaration' ||
        path.parent.type === 'ExportNamedDeclaration') {
        if (path.parentPath.parent.type === 'Program') {
            atTopLevel = true;
        }
    }
    else if (path.parent.type === 'Program') {
        atTopLevel = true;
    }
    return atTopLevel;
};
exports.isTopLevelDefinition = isTopLevelDefinition;
const isTopLevelFunctionDeclaration = (path) => {
    let hasJSXReturn = false;
    if (!(0, exports.isTopLevelDefinition)(path))
        return;
    // Create a Program node that wraps the function body
    const programNode = t.file(t.program([
        t.expressionStatement(t.functionExpression(null, path.node.params, path.node.body))
    ]));
    // Traverse the cloned body
    (0, traverse_1.default)(programNode, {
        ReturnStatement(returnPath) {
            if ((0, exports.isJSXReturn)(returnPath)) {
                hasJSXReturn = true;
                returnPath.stop();
            }
        }
    });
    if (hasJSXReturn) {
        if (!path.node.id && !path.node.id.name) {
            return (0, utils_1.throwError)('cannot define component function with no name');
        }
        return true;
    }
    return false;
};
exports.isTopLevelFunctionDeclaration = isTopLevelFunctionDeclaration;
const manageCursorFunctionDeclaration = (path, scope) => {
    if (!(0, exports.isTopLevelFunctionDeclaration)(path))
        return;
    scope.setCursor(path.node.id.name);
    scope.addComponent(path.node.id.name);
};
exports.manageCursorFunctionDeclaration = manageCursorFunctionDeclaration;
// export const MyComponentArrowFunc = () => { };
// const MyComponentArrowFunc = () => { };
const isTopLevelArrowFunctionExpressionVariableDeclaration = (path) => {
    let hasJSXReturn = false;
    if (!(0, exports.isTopLevelDefinition)(path))
        return;
    // is there an ArrowFunctionExpression ?
    let isArrowFunctionExpression = false;
    const decl = path.node.declarations[0];
    if (decl.type === 'VariableDeclarator') {
        if (decl.init.type === 'ArrowFunctionExpression') {
            isArrowFunctionExpression = true;
        }
    }
    if (!isArrowFunctionExpression)
        return;
    const functionExpression = decl.init;
    // Create a Program node that wraps the function body
    const programNode = t.file(t.program([
        functionExpression.body
    ]));
    // Traverse the cloned body
    (0, traverse_1.default)(programNode, {
        ReturnStatement(returnPath) {
            if ((0, exports.isJSXReturn)(returnPath)) {
                hasJSXReturn = true;
                returnPath.stop();
            }
        }
    });
    if (hasJSXReturn) {
        if (decl.id.type !== 'Identifier') {
            return (0, utils_1.throwError)('arrow function without Identifier name at top level');
        }
        return true;
    }
    return false;
};
exports.isTopLevelArrowFunctionExpressionVariableDeclaration = isTopLevelArrowFunctionExpressionVariableDeclaration;
const manageCursorArrowFunctionExpressionVariableDeclaration = (path, scope) => {
    const decl = path.node.declarations[0];
    if (!(0, exports.isTopLevelArrowFunctionExpressionVariableDeclaration)(path))
        return;
    const id = decl.id;
    scope.setCursor(id.name);
    scope.addComponent(id.name);
};
exports.manageCursorArrowFunctionExpressionVariableDeclaration = manageCursorArrowFunctionExpressionVariableDeclaration;
