"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.strToAst = exports.fileToAst = exports.throwError = void 0;
const fs_1 = require("fs");
const parser_1 = require("@babel/parser");
const throwError = (str) => {
    throw new Error(`Genomic Parser Error: ${str}`);
};
exports.throwError = throwError;
const fileToAst = (path, parserOptions = {
    sourceType: 'module',
    plugins: [
        'jsx', 'typescript'
    ]
}) => {
    return (0, exports.strToAst)((0, fs_1.readFileSync)(path, 'utf-8'), parserOptions);
};
exports.fileToAst = fileToAst;
const strToAst = (str, parserOptions = {
    sourceType: 'module',
    plugins: [
        'jsx', 'typescript'
    ]
}) => {
    return (0, parser_1.parse)(str, parserOptions);
};
exports.strToAst = strToAst;
